#@ MODIF E_Global Execution  DATE 16/10/2007   AUTEUR REZETTE C.REZETTE 
# -*- coding: iso-8859-1 -*-
#            CONFIGURATION MANAGEMENT OF EDF VERSION
# ======================================================================
# COPYRIGHT (C) 1991 - 2006  EDF R&D                  WWW.CODE-ASTER.ORG
# THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
# IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
# THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
# (AT YOUR OPTION) ANY LATER VERSION.                                                  
#                                                                       
# THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
# WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
# MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
# GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
#                                                                       
# YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
# ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
#    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.        
# ======================================================================

# RESPONSABLE MCOURTOI M.COURTOIS

"""
   Module dans lequel on dfinit des fonctions pour la phase d'excution.
   Ces fonctions sont indpendantes des tapes (sinon elles seraient dans
   B_ETAPE/E_ETAPE) et des concepts/ASSD, et elles sont destines  etre
   appeles par le fortran via astermodule.c.

   Ce module sera accessible via la variable globale `static_module`
   de astermodule.c.
"""

# MessageLog est l'objet qui gre l'impression des messages
# (appel par astermodule.c)
from Utilitai.Utmess import MessageLog

# ------------------------------------------------------------------------
def checksd(nomsd, typesd):
   """Vrifie la validit de la SD `nom_sd` (nom jeveux) de type `typesd`.
   Exemple : typesd = sd_maillage
   C'est le pendant de la "SD.checksd.check"  partir d'objets nomms.
   Code retour :
      0 : tout est ok
      1 : erreurs lors du checksd
      4 : on n'a meme pas pu tester
   """
   from Utilitai.Utmess import UTMESS
   nomsd  = nomsd.strip()
   typesd = typesd.lower().strip()
   
   # import
   iret = 4
   try:
      sd_module = __import__('SD.%s' % typesd, globals(), locals(), [typesd])
   except ImportError, msg:
      UTMESS('F', 'SDVERI_1', valk=typesd)
      return iret
   
   # on rcupre la classe typesd
   clas = getattr(sd_module, typesd, None)
   if clas:
      objsd = clas(nomj=nomsd)
      chk = objsd.check()
      ichk = min([1,] + [level for level, obj, msg in chk.msg])
      if ichk == 0:
         iret = 1
      else:
         iret = 0
   
   return iret

